diff -urN ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp ./src/gb/GB.cpp
--- ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp	2004-05-14 04:35:26 +0900
+++ ./src/gb/GB.cpp	2006-08-25 22:30:09 +0900
@@ -1652,146 +2690,418 @@
 
   gbLastTime = systemGetClock();
   gbFrameCount = 0;
+
+  gbScreenOn = true;
+  gbSystemMessage = false;
+
+  gbCheatWrite(true); // Emulates GS codes.
+
 }
 
 void gbWriteSaveMBC1(const char * name)
 {
-  FILE *gzFile = fopen(name,"wb");
+  if (gbRam)
+  {
+    FILE *gzFile = fopen(name,"wb");
 
-  if(gzFile == NULL) {
-    systemMessage(MSG_ERROR_CREATING_FILE, N_("Error creating file %s"), name);
-    return;
-  }
+    if(gzFile == NULL) {
+      systemMessage(MSG_ERROR_CREATING_FILE, N_("Error creating file %s"), name);
+      return;
+    }
   
-  fwrite(gbRam,
-         1,
-         gbRamSize,
-         gzFile);
+    fwrite(gbRam,
+           1,
+           (gbRamSizeMask+1),
+           gzFile);
   
-  fclose(gzFile);
+    fclose(gzFile);
+  }
 }
 
 void gbWriteSaveMBC2(const char * name)
 {
-  FILE *file = fopen(name, "wb");
+  if (gbRam)
+  {
+    FILE *file = fopen(name, "wb");
 
-  if(file == NULL) {
-    systemMessage(MSG_ERROR_CREATING_FILE, N_("Error creating file %s"), name);
-    return;
-  }
+    if(file == NULL) {
+      systemMessage(MSG_ERROR_CREATING_FILE, N_("Error creating file %s"), name);
+      return;
+    }
 
-  fwrite(&gbMemory[0xa000],
-         1,
-         256,
-         file);
+    fwrite(&gbMemory[0xa000],
+           1,
+           256,
+           file);
 
-  fclose(file);
+    fclose(file);
+  }
 }
 
 void gbWriteSaveMBC3(const char * name, bool extendedSave)
 {
+  if (gbRam || extendedSave)
+  {
+    FILE *gzFile = fopen(name,"wb");
+    if (gbRam)
+    {
+
+      if(gzFile == NULL) {
+        systemMessage(MSG_ERROR_CREATING_FILE, N_("Error creating file %s"), name);
+        return;
+      }
+  
+      fwrite(gbRam,
+             1,
+             (gbRamSizeMask+1),
+             gzFile);
+    }
+
+    if(extendedSave)
+      fwrite(&gbDataMBC3.mapperSeconds,
+             1,
+             10*sizeof(int) + sizeof(time_t),
+             gzFile);
+
+    fclose(gzFile);
+  }
+}
+
+void gbWriteSaveMBC5(const char * name)
+{
+  if (gbRam)
+  {
+    FILE *gzFile = fopen(name,"wb");
+
+    if(gzFile == NULL) {
+      systemMessage(MSG_ERROR_CREATING_FILE, N_("Error creating file %s"), name);
+      return;
+    }
+  
+    fwrite(gbRam,
+           1,
+           (gbRamSizeMask+1),
+           gzFile);
+
+    fclose(gzFile);
+  }
+}
+
+void gbWriteSaveMBC7(const char * name)
+{
+  if (gbRam)
+  {
+    FILE *file = fopen(name, "wb");
+
+    if(file == NULL) {
+      systemMessage(MSG_ERROR_CREATING_FILE, N_("Error creating file %s"), name);
+      return;
+    }
+
+    fwrite(&gbMemory[0xa000],
+           1,
+           256,
+           file);
+
+    fclose(file);
+  }
+}
+
+void gbWriteSaveTAMA5(const char * name, bool extendedSave)
+{
   FILE *gzFile = fopen(name,"wb");
 
   if(gzFile == NULL) {
     systemMessage(MSG_ERROR_CREATING_FILE, N_("Error creating file %s"), name);
     return;
   }
-  
-  fwrite(gbRam,
+  if (gbRam)
+    fwrite(gbRam,
+           1,
+           (gbRamSizeMask+1),
+           gzFile);
+
+  fwrite(gbTAMA5ram,
          1,
-         gbRamSize,
+         (gbTAMA5ramSize),
          gzFile);
 
   if(extendedSave)
-    fwrite(&gbDataMBC3.mapperSeconds,
+    fwrite(&gbDataTAMA5.mapperSeconds,
            1,
-           10*sizeof(int) + sizeof(time_t),
+           14*sizeof(int) + sizeof(time_t),
            gzFile);
   
   fclose(gzFile);
 }
 
-void gbWriteSaveMBC5(const char * name)
+void gbWriteSaveMMM01(const char * name)
 {
-  FILE *gzFile = fopen(name,"wb");
+  if (gbRam)
+  {
+    FILE *gzFile = fopen(name,"wb");
 
-  if(gzFile == NULL) {
-    systemMessage(MSG_ERROR_CREATING_FILE, N_("Error creating file %s"), name);
-    return;
-  }
+    if(gzFile == NULL) {
+      systemMessage(MSG_ERROR_CREATING_FILE, N_("Error creating file %s"), name);
+      return;
+    }
   
-  fwrite(gbRam,
-         1,
-         gbRamSize,
-         gzFile);
-
-  fclose(gzFile);
+    fwrite(gbRam,
+           1,
+           (gbRamSizeMask+1),
+           gzFile);
+  
+    fclose(gzFile);
+  }
 }
 
-void gbWriteSaveMBC7(const char * name)
+
+bool gbReadSaveMBC1(const char * name)
 {
-  FILE *file = fopen(name, "wb");
+  if (gbRam)
+  {
+    gzFile gzFile = gzopen(name, "rb");
 
-  if(file == NULL) {
-    systemMessage(MSG_ERROR_CREATING_FILE, N_("Error creating file %s"), name);
-    return;
+    if(gzFile == NULL) {
+      return false;
+    }
+  
+    int read = gzread(gzFile,
+                      gbRam,
+                      (gbRamSizeMask+1));
+  
+    if(read != (gbRamSizeMask+1)) {
+      systemMessage(MSG_FAILED_TO_READ_SGM,
+                    N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+      gzclose(gzFile);
+      gbBatteryError = true;
+      return false;
+    }
+
+    // Also checks if the battery file it bigger than gbRamSizeMask+1 ! 
+    u8 data[1];
+    data[0] = 0;
+
+    read = gzread(gzFile,
+                  data,
+                  1);
+    if(read >0) {
+      systemMessage(MSG_FAILED_TO_READ_SGM,
+                    N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+      gzclose(gzFile);
+      gbBatteryError = true;
+      return false;
+    }
+  
+    gzclose(gzFile);
+    return true;
   }
+  else
+    return false;
+}
 
-  fwrite(&gbMemory[0xa000],
-         1,
-         256,
-         file);
 
-  fclose(file);
+bool gbReadSaveMBC2(const char * name)
+{
+  if (gbRam)
+  {
+    FILE *file = fopen(name, "rb");
+
+    if(file == NULL) {
+      return false;
+    }
+
+    size_t read = fread(&gbMemory[0xa000],
+                     1,
+                     256,
+                     file);
+  
+    if(read != 256) {
+      systemMessage(MSG_FAILED_TO_READ_SGM,
+                    N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+      fclose(file);
+      gbBatteryError = true;
+      return false;
+    }
+
+    // Also checks if the battery file it bigger than gbRamSizeMask+1 ! 
+    u8 data[1];
+    data[0] = 0;
+
+    read = fread(&data[0],
+                 1,
+                 1,
+                 file);
+    if(read > 0) {
+      systemMessage(MSG_FAILED_TO_READ_SGM,
+                    N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+      fclose(file);
+      gbBatteryError = true;
+      return false;
+    }
+  
+    fclose(file);
+    return true;
+  }
+  else
+    return false;
 }
 
-bool gbReadSaveMBC1(const char * name)
+bool gbReadSaveMBC3(const char * name)
 {
   gzFile gzFile = gzopen(name, "rb");
 
   if(gzFile == NULL) {
     return false;
   }
+
+  int read = 0;
+
+  if (gbRam)
+    read = gzread(gzFile,
+                      gbRam,
+                      (gbRamSizeMask+1));
+  else
+    read = (gbRamSizeMask+1);
+    
+
+  bool res = true;
   
-  int read = gzread(gzFile,
-                    gbRam,
-                    gbRamSize);
-  
-  if(read != gbRamSize) {
-    systemMessage(MSG_FAILED_TO_READ_SGM, N_("Failed to read complete save game %s (%d)"), name, read);
-    gzclose(gzFile);
-    return false;
+  if(read != (gbRamSizeMask+1)) {
+    systemMessage(MSG_FAILED_TO_READ_SGM,
+                  N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+    gbBatteryError = true;
+    res = false;
+  } else if ((gbRomType == 0xf) || (gbRomType == 0x10)){
+    read = gzread(gzFile,
+                  &gbDataMBC3.mapperSeconds,
+                  sizeof(int)*10 + sizeof(time_t));
+
+    if(read != (sizeof(int)*10 + sizeof(time_t)) && read != 0) {
+       systemMessage(MSG_FAILED_TO_READ_RTC,N_("Failed to read RTC from save game %s (continuing)"),
+                     name);
+       res = false;
+    }
+    else if (read == 0)
+    {
+       systemMessage(MSG_FAILED_TO_READ_RTC,N_("Failed to read RTC from save game %s (continuing)"),
+                     name);
+       res = false;
+    }
+    else
+    {
+      // Also checks if the battery file it bigger than gbRamSizeMask+1+RTC ! 
+      u8 data[1];
+      data[0] = 0;
+
+      read = gzread(gzFile,
+                    data,
+                    1);
+      if(read >0) {
+        systemMessage(MSG_FAILED_TO_READ_SGM,
+                      N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+        gbBatteryError = true;
+        res = false;
+      }
+    }
   }
   
   gzclose(gzFile);
-  return true;
+  return res;
 }
 
-bool gbReadSaveMBC2(const char * name)
+bool gbReadSaveMBC5(const char * name)
 {
-  FILE *file = fopen(name, "rb");
+  if (gbRam)
+  {
+    gzFile gzFile = gzopen(name, "rb");
 
-  if(file == NULL) {
-    return false;
+    if(gzFile == NULL) {
+      return false;
+    }
+
+    int read = gzread(gzFile,
+                      gbRam,
+                      (gbRamSizeMask+1));
+  
+    if(read != (gbRamSizeMask+1)) {
+      systemMessage(MSG_FAILED_TO_READ_SGM,
+                    N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+      gzclose(gzFile);
+      gbBatteryError = true;
+      return false;
+    }
+
+
+    // Also checks if the battery file it bigger than gbRamSizeMask+1 ! 
+    u8 data[1];
+    data[0] = 0;
+
+    read = gzread(gzFile,
+                  data,
+                  1);
+    if(read >0) {
+      systemMessage(MSG_FAILED_TO_READ_SGM,
+                    N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+      gzclose(gzFile);
+      gbBatteryError = true;
+      return false;
+    }
+  
+    gzclose(gzFile);
+    return true;
   }
+  else
+    return false;
+}
 
-  int read = fread(&gbMemory[0xa000],
-                   1,
-                   256,
-                   file);
+bool gbReadSaveMBC7(const char * name)
+{
+  if (gbRam)
+  {
+    FILE *file = fopen(name, "rb");
+
+    if(file == NULL) {
+      return false;
+    }
+
+    size_t read = fread(&gbMemory[0xa000],
+                     1,
+                     256,
+                     file);
+  
+    if(read != 256) {
+      systemMessage(MSG_FAILED_TO_READ_SGM,
+                    N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+      fclose(file);
+      gbBatteryError = true;
+      return false;
+    }
+
+    // Also checks if the battery file it bigger than gbRamSizeMask+1 ! 
+    u8 data[1];
+    data[0] = 0;
+
+    read = fread(&data[0],
+                 1,
+                 1,
+                 file);
+    if(read > 0) {
+      systemMessage(MSG_FAILED_TO_READ_SGM,
+                    N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+      fclose(file);
+      gbBatteryError = true;
+      return false;
+    }
   
-  if(read != 256) {
-    systemMessage(MSG_FAILED_TO_READ_SGM,
-                  N_("Failed to read complete save game %s (%d)"), name, read);
     fclose(file);
-    return false;
+    return true;
   }
-  
-  fclose(file);
-  return true;
+  else
+    return false;
 }
 
-bool gbReadSaveMBC3(const char * name)
+bool gbReadSaveTAMA5(const char * name)
 {
   gzFile gzFile = gzopen(name, "rb");
 
@@ -1799,25 +3109,57 @@
     return false;
   }
 
-  int read = gzread(gzFile,
-                    gbRam,
-                    gbRamSize);
+  int read = 0;
+
+  if (gbRam)
+    read = gzread(gzFile,
+                      gbRam,
+                      (gbRamSizeMask+1));
+  else
+    read = gbRamSizeMask;
+
+  read += gzread(gzFile,
+                    gbTAMA5ram,
+                    gbTAMA5ramSize);
 
   bool res = true;
   
-  if(read != gbRamSize) {
+  if(read != (gbRamSizeMask+gbTAMA5ramSize+1)) {
     systemMessage(MSG_FAILED_TO_READ_SGM,
-                  N_("Failed to read complete save game %s (%d)"), name, read);
+                  N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+    gbBatteryError = true;
+    res = false;
   } else {
     read = gzread(gzFile,
-                  &gbDataMBC3.mapperSeconds,
-                  sizeof(int)*10 + sizeof(time_t));
+                  &gbDataTAMA5.mapperSeconds,
+                  sizeof(int)*14 + sizeof(time_t));
 
-    if(read != (sizeof(int)*10 + sizeof(time_t)) && read != 0) {
-      systemMessage(MSG_FAILED_TO_READ_RTC,
-                    N_("Failed to read RTC from save game %s (continuing)"),
-                    name);
-      res = false;
+    if(read != (sizeof(int)*14 + sizeof(time_t)) && read != 0) {
+       systemMessage(MSG_FAILED_TO_READ_RTC,N_("Failed to read RTC from save game %s (continuing)"),
+                     name);
+       res = false;
+    }
+    else if (read == 0)
+    {
+       systemMessage(MSG_FAILED_TO_READ_RTC,N_("Failed to read RTC from save game %s (continuing)"),
+                     name);
+       res = false;
+    }
+    else
+    {
+      // Also checks if the battery file it bigger than gbRamSizeMask+1+RTC ! 
+      u8 data[1];
+      data[0] = 0;
+
+      read = gzread(gzFile,
+                    data,
+                    1);
+      if(read >0) {
+        systemMessage(MSG_FAILED_TO_READ_SGM,
+                      N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+        gbBatteryError = true;
+        res = false;
+      }
     }
   }
   
@@ -1825,51 +3167,49 @@
   return res;
 }
 
-bool gbReadSaveMBC5(const char * name)
-{
-  gzFile gzFile = gzopen(name, "rb");
 
-  if(gzFile == NULL) {
-    return false;
-  }
+bool gbReadSaveMMM01(const char * name)
+{
+  if (gbRam)
+  {
+    gzFile gzFile = gzopen(name, "rb");
+
+    if(gzFile == NULL) {
+      return false;
+    }  
+  
+    int read = gzread(gzFile,
+                      gbRam,
+                      (gbRamSizeMask+1));
+  
+    if(read != (gbRamSizeMask+1)) {
+      systemMessage(MSG_FAILED_TO_READ_SGM,
+                    N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+      gzclose(gzFile);
+      gbBatteryError = true;
+      return false;
+    }
+
+    // Also checks if the battery file it bigger than gbRamSizeMask+1 ! 
+    u8 data[1];
+    data[0] = 0;
 
-  int read = gzread(gzFile,
-                    gbRam,
-                    gbRamSize);
+    read = gzread(gzFile,
+                  data,
+                  1);
+    if(read >0) {
+      systemMessage(MSG_FAILED_TO_READ_SGM,
+                    N_("Battery file's size incompatible with the rom settings %s (%d).\nWarning : save of the battery file is now disabled !"), name, read);
+      gzclose(gzFile);
+      gbBatteryError = true;
+      return false;
+    }
   
-  if(read != gbRamSize) {
-    systemMessage(MSG_FAILED_TO_READ_SGM,
-                  N_("Failed to read complete save game %s (%d)"), name, read);
     gzclose(gzFile);
-    return false;
-  }
-  
-  gzclose(gzFile);
-  return true;
-}
-
-bool gbReadSaveMBC7(const char * name)
-{
-  FILE *file = fopen(name, "rb");
-
-  if(file == NULL) {
-    return false;
+    return true;
   }
-
-  int read = fread(&gbMemory[0xa000],
-                   1,
-                   256,
-                   file);
-  
-  if(read != 256) {
-    systemMessage(MSG_FAILED_TO_READ_SGM,
-                  N_("Failed to read complete save game %s (%d)"), name, read);
-    fclose(file);
+  else
     return false;
-  }
-  
-  fclose(file);
-  return true;
 }
 
 void gbInit()
@@ -1878,7 +3218,6 @@
   gbSgbInit();
 
   gbMemory = (u8 *)malloc(65536);
-  memset(gbMemory,0, 65536);
   
   pix = (u8 *)calloc(1,4*257*226);
   
@@ -1888,20 +3227,23 @@
 bool gbWriteBatteryFile(const char *file, bool extendedSave)
 {
   if(gbBattery) {
-    int type = gbRom[0x147];
-
-    switch(type) {
+    switch(gbRomType) {
     case 0x03:
       gbWriteSaveMBC1(file);
       break;
     case 0x06:
       gbWriteSaveMBC2(file);
       break;
+    case 0x0d:
+      gbWriteSaveMMM01(file);
+      break;
     case 0x0f:
     case 0x10:
-    case 0x13:
       gbWriteSaveMBC3(file, extendedSave);
       break;
+    case 0x13:
+    case 0xfc:
+      gbWriteSaveMBC3(file, false);
     case 0x1b:
     case 0x1e:
       gbWriteSaveMBC5(file);
@@ -1909,6 +3251,9 @@
     case 0x22:
       gbWriteSaveMBC7(file);
       break;
+    case 0xfd:
+      gbWriteSaveTAMA5(file, extendedSave);
+      break;
     case 0xff:
       gbWriteSaveMBC1(file);
       break;
@@ -1919,26 +3264,30 @@
 
 bool gbWriteBatteryFile(const char *file)
 {
-  gbWriteBatteryFile(file, true);
-  return true;
+  if (!gbBatteryError)
+  {
+    gbWriteBatteryFile(file, true);
+    return true;
+  }
+  else return false;
 }
 
 bool gbReadBatteryFile(const char *file)
 {
   bool res = false;
   if(gbBattery) {
-    int type = gbRom[0x147];
-    
-    switch(type) {
+    switch(gbRomType) {
     case 0x03:
       res = gbReadSaveMBC1(file);
       break;
     case 0x06:
       res = gbReadSaveMBC2(file);
       break;
+    case 0x0d:
+      res = gbReadSaveMMM01(file);
+      break;
     case 0x0f:
     case 0x10:
-    case 0x13:
       if(!gbReadSaveMBC3(file)) {
         time(&gbDataMBC3.mapperLastTime);
         struct tm *lt;
@@ -1954,12 +3303,54 @@
       }
       res = true;
       break;
+    case 0x13:
+    case 0xfc:
+      res = gbReadSaveMBC3(file);
     case 0x1b:
     case 0x1e:
       res = gbReadSaveMBC5(file);
       break;
     case 0x22:
       res = gbReadSaveMBC7(file);
+    case 0xfd:
+      if(!gbReadSaveTAMA5(file)) {
+        u8 gbDaysinMonth [12] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
+        time(&gbDataTAMA5.mapperLastTime);
+        struct tm *lt;
+        lt = localtime(&gbDataTAMA5.mapperLastTime);
+        gbDataTAMA5.mapperSeconds = lt->tm_sec;
+        gbDataTAMA5.mapperMinutes = lt->tm_min;
+        gbDataTAMA5.mapperHours = lt->tm_hour;
+        gbDataTAMA5.mapperDays = 1;
+        gbDataTAMA5.mapperMonths = 1;
+        gbDataTAMA5.mapperYears = 1970;
+        int days = lt->tm_yday+365*3;
+        while (days)
+        {
+          gbDataTAMA5.mapperDays++;
+          days--;
+          if (gbDataTAMA5.mapperDays>gbDaysinMonth[gbDataTAMA5.mapperMonths-1])
+          {
+            gbDataTAMA5.mapperDays = 1;
+            gbDataTAMA5.mapperMonths++;
+            if (gbDataTAMA5.mapperMonths>12)
+            {
+               gbDataTAMA5.mapperMonths = 1;
+               gbDataTAMA5.mapperYears++;
+               if ((gbDataTAMA5.mapperYears & 3) == 0)
+                 gbDaysinMonth[1] = 29;
+               else
+                 gbDaysinMonth[1] = 28;
+            }
+          }
+        }
+        gbDataTAMA5.mapperControl = (gbDataTAMA5.mapperControl & 0xfe) |
+          (lt->tm_yday > 255 ? 1: 0);
+        res = false;
+        break;
+      }
+      res = true;
+      break;
     case 0xff:
       res = gbReadSaveMBC1(file);
       break;
@@ -1978,7 +3369,6 @@
     return false;
   }
   
-  //  long size = ftell(file);
   fseek(file, 0x4, SEEK_SET);
   char buffer[16];
   char buffer2[16];
@@ -1995,9 +3385,9 @@
     return false;
   }
   fseek(file, 0x13, SEEK_SET);
-  int read = 0;
+  size_t read = 0;
   int toRead = 0;
-  switch(gbRom[0x147]) {
+  switch(gbRomType) {
   case 0x03:
   case 0x0f:
   case 0x10:
@@ -2005,8 +3395,8 @@
   case 0x1b:
   case 0x1e:
   case 0xff:
-    read = fread(gbRam, 1, gbRamSize, file);
-    toRead = gbRamSize;
+    read = fread(gbRam, 1, (gbRamSizeMask+1), file);
+    toRead = (gbRamSizeMask+1);
     break;
   case 0x06:
   case 0x22:
@@ -2053,7 +3443,7 @@
   { &gbTimerClockTicks, sizeof(int) },
   { &gbSerialTicks, sizeof(int) },
   { &gbSerialBits, sizeof(int) },
-  { &gbInterrupt, sizeof(int) },
+  { &gbInt48Signal, sizeof(int) },
   { &gbInterruptWait, sizeof(int) },
   { &gbSynchronizeTicks, sizeof(int) },
   { &gbTimerOn, sizeof(int) },
@@ -2109,9 +3499,13 @@
 
 static bool gbWriteSaveState(gzFile gzFile)
 {
+    
   utilWriteInt(gzFile, GBSAVE_GAME_VERSION);
 
   utilGzWrite(gzFile, &gbRom[0x134], 15);
+
+  utilWriteInt(gzFile, useBios);
+  utilWriteInt(gzFile, inBios);
   
   utilWriteData(gzFile, gbSaveGameStruct);
 
@@ -2120,24 +3514,24 @@
   if(gbSgbMode) {
     gbSgbSaveGame(gzFile);
   }
-  
+
   utilGzWrite(gzFile, &gbDataMBC1, sizeof(gbDataMBC1));
   utilGzWrite(gzFile, &gbDataMBC2, sizeof(gbDataMBC2));
   utilGzWrite(gzFile, &gbDataMBC3, sizeof(gbDataMBC3));
   utilGzWrite(gzFile, &gbDataMBC5, sizeof(gbDataMBC5));
   utilGzWrite(gzFile, &gbDataHuC1, sizeof(gbDataHuC1));
   utilGzWrite(gzFile, &gbDataHuC3, sizeof(gbDataHuC3));
-
-  // not saved anymore
-  //  gzwrite(gzFile, pix, 256*224*sizeof(u16));
+  utilGzWrite(gzFile, &gbDataTAMA5, sizeof(gbDataTAMA5));
+  if (gbTAMA5ram != NULL)
+    utilGzWrite(gzFile, gbTAMA5ram, gbTAMA5ramSize);
+  utilGzWrite(gzFile, &gbDataMMM01, sizeof(gbDataMMM01));
 
   utilGzWrite(gzFile, gbPalette, 128 * sizeof(u16));
-  // todo: remove
-  utilGzWrite(gzFile, gbPalette, 128 * sizeof(u16));
   
   utilGzWrite(gzFile, &gbMemory[0x8000], 0x8000);
   
   if(gbRamSize && gbRam) {
+    utilWriteInt(gzFile, gbRamSize);
     utilGzWrite(gzFile, gbRam, gbRamSize);
   }
 
@@ -2149,7 +3543,19 @@
   gbSoundSaveGame(gzFile);  
 
   gbCheatsSaveGame(gzFile);
-  
+
+  utilWriteInt(gzFile, gbLcdModeDelayed);
+  utilWriteInt(gzFile, gbLcdTicksDelayed);
+  utilWriteInt(gzFile, gbLcdLYIncrementTicksDelayed);
+  utilWriteInt(gzFile, gbSpritesTicks[299]);
+  utilWriteInt(gzFile, gbTimerModeChange);
+  utilWriteInt(gzFile, gbTimerOnChange);
+  utilWriteInt(gzFile, gbHardware);
+  utilWriteInt(gzFile, gbBlackScreen);
+  utilWriteInt(gzFile, oldRegister_WY);
+  utilWriteInt(gzFile, gbWindowLine);
+  utilWriteInt(gzFile, inUseRegister_WY);
+  utilWriteInt(gzFile, gbScreenOn);
   return true;
 }
 
@@ -2206,9 +3612,58 @@
                   romname, &gbRom[0x134]);
     return false;
   }
+
+
+  bool ub = false;
+  bool ib = false;
+
+  if (version >= 11)
+  {
+    ub = utilReadInt(gzFile) ? true : false;
+    ib = utilReadInt(gzFile) ? true : false;
+
+    if((ub != useBios) && (ib)) {
+      if(useBios)
+        systemMessage(MSG_SAVE_GAME_NOT_USING_BIOS,
+                      N_("Save game is not using the BIOS files"));
+      else
+        systemMessage(MSG_SAVE_GAME_USING_BIOS,
+                      N_("Save game is using the BIOS file"));
+      return false;
+    }
+  }
+
+  gbReset();
+
+  inBios = ib;
   
   utilReadData(gzFile, gbSaveGameStruct);
 
+
+  // Correct crash when loading color gameboy save in regular gameboy type.
+  if (!gbCgbMode)
+  {
+    if(gbVram != NULL) {
+      free(gbVram);
+      gbVram = NULL;
+    }
+    if(gbWram != NULL) {
+      free(gbWram);
+      gbWram = NULL;
+    }
+  }
+  else
+  {
+    if(gbVram == NULL)
+      gbVram = (u8 *)malloc(0x4000);
+    if(gbWram == NULL)
+      gbWram = (u8 *)malloc(0x8000);
+    memset(gbVram,0,0x4000);
+    memset(gbPalette,0, 2*128);
+  }
+
+
+
   if(version >= GBSAVE_GAME_VERSION_7) {
     utilGzRead(gzFile, &IFF, 2);
   }
@@ -2218,8 +3673,10 @@
   } else {
     gbSgbMask = 0; // loading a game at the wrong time causes no display
   }
-  
-  utilGzRead(gzFile, &gbDataMBC1, sizeof(gbDataMBC1));
+  if (version<11)
+    utilGzRead(gzFile, &gbDataMBC1, sizeof(gbDataMBC1) - sizeof(int));
+  else
+    utilGzRead(gzFile, &gbDataMBC1, sizeof(gbDataMBC1));
   utilGzRead(gzFile, &gbDataMBC2, sizeof(gbDataMBC2));
   if(version < GBSAVE_GAME_VERSION_4)
     // prior to version 4, there was no adjustment for the time the game
@@ -2231,6 +3688,13 @@
   utilGzRead(gzFile, &gbDataMBC5, sizeof(gbDataMBC5));
   utilGzRead(gzFile, &gbDataHuC1, sizeof(gbDataHuC1));
   utilGzRead(gzFile, &gbDataHuC3, sizeof(gbDataHuC3));
+  if (version>=11)
+  {
+    utilGzRead(gzFile, &gbDataTAMA5, sizeof(gbDataTAMA5));
+    if (gbTAMA5ram != NULL)
+      utilGzRead(gzFile, gbTAMA5ram, gbTAMA5ramSize);
+    utilGzRead(gzFile, &gbDataMMM01, sizeof(gbDataMMM01));
+  }
 
   if(version < GBSAVE_GAME_VERSION_5) {
     utilGzRead(gzFile, pix, 256*224*sizeof(u16));
@@ -2242,8 +3706,8 @@
   } else
     utilGzRead(gzFile, gbPalette, 128 * sizeof(u16));
 
-  // todo: remove
-  utilGzRead(gzFile, gbPalette, 128 * sizeof(u16));
+  if (version < 11)
+    utilGzRead(gzFile, gbPalette, 128 * sizeof(u16));
   
   if(version < GBSAVE_GAME_VERSION_10) {
     if(!gbCgbMode && !gbSgbMode) {
@@ -2255,10 +3719,35 @@
   utilGzRead(gzFile, &gbMemory[0x8000], 0x8000);
 
   if(gbRamSize && gbRam) {
-    utilGzRead(gzFile, gbRam, gbRamSize);
+    if (version < 11)
+      utilGzRead(gzFile, gbRam, gbRamSize);
+    else
+    {
+      int ramSize = utilReadInt(gzFile);
+      utilGzRead(gzFile, gbRam, (gbRamSize>ramSize) ? ramSize : gbRamSize);
+      if (ramSize>gbRamSize)
+        gzseek(gzFile,ramSize-gbRamSize,SEEK_CUR);
+    }
   }
-  
-  gbMemoryMap[0x00] = &gbRom[0x0000];
+
+  memset(gbSCYLine, register_SCY, sizeof(gbSCYLine));
+  memset(gbSCXLine, register_SCX, sizeof(gbSCXLine));
+  memset(gbBgpLine, (gbBgp[0] | (gbBgp[1]<<2) | (gbBgp[2]<<4) |
+         (gbBgp[3]<<6)), sizeof(gbBgpLine));
+  memset(gbObp0Line, (gbObp0[0] | (gbObp0[1]<<2) | (gbObp0[2]<<4) |
+         (gbObp0[3]<<6)), sizeof(gbObp0Line));
+  memset(gbObp1Line, (gbObp1[0] | (gbObp1[1]<<2) | (gbObp1[2]<<4) |
+         (gbObp1[3]<<6)), sizeof(gbObp1Line));
+  memset(gbSpritesTicks, 0x0, sizeof(gbSpritesTicks));
+  
+  if (inBios)
+  {
+    gbMemoryMap[0x00] = &gbMemory[0x0000];
+    memcpy ((u8 *)(gbMemory), (u8 *)(gbRom), 0x1000);
+    memcpy ((u8 *)(gbMemory), (u8 *)(bios), 0x100);
+  }
+  else
+    gbMemoryMap[0x00] = &gbRom[0x0000];
   gbMemoryMap[0x01] = &gbRom[0x1000];
   gbMemoryMap[0x02] = &gbRom[0x2000];
   gbMemoryMap[0x03] = &gbRom[0x3000];
@@ -2275,9 +3764,7 @@
   gbMemoryMap[0x0e] = &gbMemory[0xe000];
   gbMemoryMap[0x0f] = &gbMemory[0xf000];    
 
-  int type = gbRom[0x147];
-  
-  switch(type) {
+  switch(gbRomType) {
   case 0x00:
   case 0x01:
   case 0x02:
@@ -2290,6 +3777,12 @@
     // MBC2
     memoryUpdateMapMBC2();
     break;
+  case 0x0b:
+  case 0x0c:
+  case 0x0d:
+    // MMM01
+    memoryUpdateMapMMM01();
+    break;
   case 0x0f:
   case 0x10:
   case 0x11:
@@ -2314,6 +3807,14 @@
     // MBC 7
     memoryUpdateMapMBC7();
     break;
+  case 0x56:
+    // GS3
+    memoryUpdateMapGS3();
+    break;
+  case 0xfd:
+    // TAMA5
+    memoryUpdateMapTAMA5();
+    break;
   case 0xfe:
     // HuC3
     memoryUpdateMapHuC3();
@@ -2339,7 +3840,11 @@
 
   gbSoundReadGame(version, gzFile);
 
-  if(gbBorderOn) {
+  if (gbCgbMode && gbSgbMode) {
+    gbSgbMode = 0;
+  }
+
+  if(gbBorderOn && !gbSgbMask) {
     gbSgbRenderBorder();
   }
   
@@ -2348,6 +3853,85 @@
   if(version > GBSAVE_GAME_VERSION_1)
     gbCheatsReadGame(gzFile, version);
 
+  if (version<11)
+  {
+    gbWriteMemory(0xff00, 0);
+    gbMemory[0xff04] = register_DIV;
+    gbMemory[0xff05] = register_TIMA;
+    gbMemory[0xff06] = register_TMA;
+    gbMemory[0xff07] = register_TAC;
+    gbMemory[0xff40] = register_LCDC;
+    gbMemory[0xff42] = register_SCY;
+    gbMemory[0xff43] = register_SCX;
+    gbMemory[0xff44] = register_LY;
+    gbMemory[0xff45] = register_LYC;
+    gbMemory[0xff46] = register_DMA;
+    gbMemory[0xff4a] = register_WY;
+    gbMemory[0xff4b] = register_WX;
+    gbMemory[0xff4f] = register_VBK;
+    gbMemory[0xff51] = register_HDMA1;
+    gbMemory[0xff52] = register_HDMA2;
+    gbMemory[0xff53] = register_HDMA3;
+    gbMemory[0xff54] = register_HDMA4;
+    gbMemory[0xff55] = register_HDMA5;
+    gbMemory[0xff70] = register_SVBK;
+    gbMemory[0xffff] = register_IE;
+    GBDIV_CLOCK_TICKS = 64;
+
+    if (gbSpeed)
+      gbDivTicks /=2;
+
+    if ((gbLcdMode == 0) && (register_STAT & 8))
+      gbInt48Signal |= 1;
+    if ((gbLcdMode == 1) && (register_STAT & 0x10))
+      gbInt48Signal |= 2;
+    if ((gbLcdMode == 2) && (register_STAT & 0x20))
+      gbInt48Signal |= 4;
+    if ((register_LY==register_LYC) && (register_STAT & 0x40))
+      gbInt48Signal |= 8;
+
+      gbLcdLYIncrementTicks = GBLY_INCREMENT_CLOCK_TICKS;
+
+      if (gbLcdMode == 2)
+        gbLcdLYIncrementTicks-=GBLCD_MODE_2_CLOCK_TICKS-gbLcdTicks;
+      else if (gbLcdMode == 3)
+        gbLcdLYIncrementTicks -=GBLCD_MODE_2_CLOCK_TICKS+GBLCD_MODE_3_CLOCK_TICKS-gbLcdTicks;
+      else if (gbLcdMode == 0)
+        gbLcdLYIncrementTicks =gbLcdTicks;
+      else if (gbLcdMode == 1)
+      {
+         gbLcdLYIncrementTicks = gbLcdTicks % GBLY_INCREMENT_CLOCK_TICKS;
+         if (register_LY == 0x99)
+            gbLcdLYIncrementTicks =gbLine99Ticks;
+         else if (register_LY == 0)
+            gbLcdLYIncrementTicks += GBLY_INCREMENT_CLOCK_TICKS;
+      }
+
+    gbLcdModeDelayed = gbLcdMode;
+    gbLcdTicksDelayed = gbLcdTicks--;
+    gbLcdLYIncrementTicksDelayed = gbLcdLYIncrementTicks--;
+    gbInterruptWait = 0;
+    memset(gbSpritesTicks,0,sizeof(gbSpritesTicks));
+  }
+  else
+  {
+    gbLcdModeDelayed = utilReadInt(gzFile);
+    gbLcdTicksDelayed = utilReadInt(gzFile);
+    gbLcdLYIncrementTicksDelayed = utilReadInt(gzFile);
+    gbSpritesTicks[299] = utilReadInt(gzFile) & 0xff;
+    gbTimerModeChange = (utilReadInt(gzFile) ? true : false);
+    gbTimerOnChange = (utilReadInt(gzFile) ? true : false);
+    gbHardware = utilReadInt(gzFile);
+    gbBlackScreen = (utilReadInt(gzFile) ? true : false);
+    oldRegister_WY = utilReadInt(gzFile);
+    gbWindowLine = utilReadInt(gzFile);
+    inUseRegister_WY = utilReadInt(gzFile);
+    gbScreenOn = (utilReadInt(gzFile) ? true : false);
+  }
+
+  if (gbSpeed)
+    gbLine99Ticks *= 2;
+
   systemSaveUpdateCounter = SYSTEM_SAVE_NOT_UPDATED;
 
   return true;
@@ -2432,13 +4016,18 @@
     gbWram = NULL;
   }
 
+  if(gbTAMA5ram != NULL) {
+    free(gbTAMA5ram);
+    gbTAMA5ram = NULL;
+  }
+
   systemSaveUpdateCounter = SYSTEM_SAVE_NOT_UPDATED;
 }
 
 bool gbLoadRom(const char *szFile)
 {
   int size = 0;
-  
+
   if(gbRom != NULL) {
     gbCleanUp();
   }
@@ -2453,6 +4042,14 @@
     return false;
 
   gbRomSize = size;
+
+  gbBatteryError = false;
+
+  if(bios != NULL) {
+    free(bios);
+    bios = NULL;
+  }
+  bios = (u8 *)calloc(1,0x100);
   
   return gbUpdateSizes();
 }
